LeetCode-888.Fair Candy Swap(公平的糖果棒交换)

公平的糖果棒交换

爱丽丝和鲍勃有不同大小的糖果棒:A[i] 是爱丽丝拥有的第 i 根糖果棒的大小,B[j] 是鲍勃拥有的第 j 根糖果棒的大小。
因为他们是朋友,所以他们想交换一根糖果棒,这样交换后,他们都有相同的糖果总量。(一个人拥有的糖果总量是他们拥有的糖果棒大小的总和。)
返回一个整数数组 ans,其中 ans[0] 是爱丽丝必须交换的糖果棒的大小,ans[1] 是鲍勃必须交换的糖果棒的大小。
如果有多个答案,你可以返回其中任何一个。保证答案存在。
示例 1:

输入:A = [1,1], B = [2,2]
输出:[1,2]

示例 2:

输入:A = [1,2], B = [2,3]
输出:[1,2]

示例 3:

输入:A = [2], B = [1,3]
输出:[2,3]

示例 4:

输入:A = [1,2,5], B = [2,4]
输出:[5,4]

提示:

  1. 1 <= A.length <= 10000
  2. 1 <= B.length <= 10000
  3. 1 <= A[i] <= 100000
  4. 1 <= B[i] <= 100000
  5. 保证爱丽丝与鲍勃的糖果总量不同。
  6. 答案肯定存在

Fair Candy Swap

Alice and Bob have candy bars of different sizes: A[i] is the size of the i-th bar of candy that Alice has, and B[j] is the size of the j-th bar of candy that Bob has.
Since they are friends, they would like to exchange one candy bar each so that after the exchange, they both have the same total amount of candy. (The total amount of candy a person has is the sum of the sizes of candy bars they have.)
Return an integer array ans where ans[0] is the size of the candy bar that Alice must exchange, and ans[1] is the size of the candy bar that Bob must exchange.
If there are multiple answers, you may return any one of them. It is guaranteed an answer exists.
Example 1:

Input: A = [1,1], B = [2,2]
Output: [1,2]

Example 2:

Input: A = [1,2], B = [2,3]
Output: [1,2]

Example 3:

Input: A = [2], B = [1,3]
Output: [2,3]

Example 4:

Input: A = [1,2,5], B = [2,4]
Output: [5,4]

Note:

  • 1 <= A.length <= 10000
  • 1 <= B.length <= 10000
  • 1 <= A[i] <= 100000
  • 1 <= B[i] <= 100000
  • It is guaranteed that Alice and Bob have different total amounts of candy.
  • It is guaranteed there exists an answer.

方法一:哈希表
设爱丽丝和鲍勃的糖果总数分别为 s u m A sumA sumA s u m B sumB sumB,交换的糖果数分别为 x A xA xA x B xB xB,由此我们有等式:
s u m A − x A + x B = s u m B + x A − x B sumA-xA+xB=sumB+xA-xB sumAxA+xB=sumB+xAxB
化简可得:
x A = x B + s u m A − s u m B 2 xA=xB+\frac{sumA-sumB}{2} xA=xB+2sumAsumB
因此对于
∀ x B ∈ B , ∃ x A ∈ A , s . t .   x A = x B + s u m A − s u m B 2 \forall xB\in B,\exists xA\in A,s.t.\ xA=xB+\frac{sumA-sumB}{2} xBB,xAA,s.t. xA=xB+2sumAsumB
那么{xA, xB}就是一组可行解。
为了加快查找速度,我们使用哈希表。

class Solution {
   public:
    vector<int> fairCandySwap(vector<int>& A, vector<int>& B) {
        int sumA = accumulate(A.begin(), A.end(), 0);
        int sumB = accumulate(B.begin(), B.end(), 0);
        int delta = (sumA - sumB) >> 1;
    	unordered_set<int> hashA(A.begin(), A.end());
    	vector<int> ret(2);	//因为答案一定存在,所以这样写也不会出错
    	for(auto xB: B){
    		int xA = xB + delta;
    		if(hashA.count(xA)){	//能找到解
    			ret[0] = xA;
    			ret[1] = xB;
    			break;
    		}
    	}
    	return ret;
    }
};

方法二:双指针
首先将两个数组升序排序。
Δ = s u m A − s u m B 2 \Delta=\frac{sumA-sumB}{2} Δ=2sumAsumB
根据上面的分析,我们知道有以下等式
x A − x B = Δ xA-xB=\Delta xAxB=Δ
ij为两个指针,同时设 k = A [ i ] − B [ j ] k=A[i]-B[j] k=A[i]B[j]我们有以下三种情况:

  1. k==delta,直接返回答案
  2. k>delta,增大j
  3. k<delta,增大i

由此,代码:

class Solution {
   public:
    vector<int> fairCandySwap(vector<int>& A, vector<int>& B) {
        int sumA = accumulate(A.begin(), A.end(), 0);
        int sumB = accumulate(B.begin(), B.end(), 0);
        int delta = (sumA - sumB) >> 1;
        vector<int> ret(2);
        sort(A.begin(), A.end());
        sort(B.begin(), B.end());
        int i = 0, j = 0;
        while (i < A.size() && j < B.size()) {
            int k = A[i] - B[j];
            if (k == delta) {
                ret[0] = A[i];
                ret[1] = B[j];
                break;
            } else if (k > delta) {
                ++j;
            } else {
                ++i;
            }
        }
        return ret;
    }
};
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值